<template>
  <div class="col-12">
    <div class="mb-3">
      <div class="mt-2 mb-4">
        <div class="row">
          <!-- TITLE -->
          <div class="col-8 offset-1">
            <h3>{{ title }}</h3>
          </div>
          <!-- EDIT / DELETE -->
          <div class="col-2">
            <datasetDetailsEditButton :id="id"
                                      :title="title"
                                      :catalogID="catalogue"
                                      :categories="categories"
                                      :contactPoints="contact"
                                      :description="description"
                                      :distributions="distributions"
                                      :publisher="publisher"
                                      :keywords="keywords"></datasetDetailsEditButton>
            <datasetDetailsDeleteButton :id="id"
                                        :catalogID="catalogue"></datasetDetailsDeleteButton>
          </div>
        </div>
        <hr>
      </div>
      <!-- DESCRIPTION -->
      <div class="mt-2">
        <div class="row">
          <div class="col-10 offset-1">
            <p>{{ description }}</p>
          </div>
        </div>
      </div>
      <!-- DISTRIBUTIONS -->
      <div class="mt-2">
        <div class="row">
          <div class="col-12">
            <div class="row">
              <div class="col-10 offset-1 py-2 text-left">
                <h3>{{ $t('message.metadata.distributions') }} ({{ distributions.length }})</h3>
              </div>
              <ul class="list list-unstyled col-12" v-if="distributions.length > 0">
                <!-- DISTRIBUTION -->
                <li class="row" v-for="(distribution, i) in distributions" :key="`distribution${i}`">
                  <span class="d-inline-block col-md-1 col-2 pt-3 pr-md-1 pr-0 m-md-0 m-auto">
                    <div v-if="distribution.format" class="circle float-md-right text-center text-white text-truncate"
                         :type="distribution.format.substring(distribution.format.lastIndexOf('/') + 1)"
                         :title="distribution.format.substring(distribution.format.lastIndexOf('/') + 1)">
                      <span>{{ distribution.format.substring(distribution.format.lastIndexOf('/') + 1) }}</span>
                    </div>
                  </span>
                  <span class="col-10">
                    <span class="row">
                      <span class="d-inline-block col-md-7 col-12">
                        <h6 class="m-0">{{ distribution.title }}</h6>
                        <span class="mt-2 d-block text-muted text-truncate">
                          <small>
                            {{ distribution.description }}
                          </small>
                        </span>
                        <small class="mt-2 d-block">
                          <span class="font-weight-bold">
                            {{ $t('message.metadata.license') }} : {{ distribution.licence }}
                          </span>
                        </small>
                      </span>
                      <span class="col-md-5 col-12 mt-2 text-md-right text-left">
                        <span class="d-inline-block">
                          <small class="pr-1">{{ filterDateFormatEU(distribution.releaseDate) }}</small>
                        </span>
                        <span class="download dropdown d-inline-block"
                              v-if="showDownloadDropdown(distribution)">
                          <button class="btn btn-sm btn-primary p-0 pl-2 w-100"
                                  type="button"
                                  data-toggle="dropdown"
                                  aria-haspopup="true"
                                  aria-expanded="false"
                                  title="Download">
                            {{ $t('message.datasetDetails.download') }}
                            <i class="material-icons small-icon float-right align-bottom">keyboard_arrow_down</i>
                          </button>
                          <div class="dropdown-menu dropdown-menu-right bg-light">
                            <span v-if="showAccessUrl(distribution)">
                              <span class="dropdown-item d-block px-3 text-right">
                                <input class="d-inline-block mr-2 py-0 px-1 w-75 small border border-secondary bg-white"
                                      type="text"
                                      :value="`${distribution.accessUrl}`">
                                <app-link class="text-dark text-decoration-none"
                                          :to="distribution.accessUrl"
                                          target="_blank">
                                  <i class="material-icons align-bottom">open_in_new</i>
                                </app-link>
                                <i class="copy-text material-icons float-right align-bottom" @click="setClipboard(distribution.accessUrl)">file_copy</i>
                              </span>
                            </span>
                            <span v-if="showDownloadUrl(distribution)">
                              <span class="dropdown-item d-block px-3 text-right">
                                <input class="d-inline-block mr-2 py-0 px-1 w-75 small border border-secondary bg-white"
                                      type="text"
                                      :value="`${distribution.downloadUrl}`">
                                <app-link class="text-dark text-decoration-none"
                                          :to="distribution.downloadUrl"
                                          target="_blank">
                                  <i class="material-icons align-bottom">open_in_new</i>
                                </app-link>
                                <i class="copy-text material-icons float-right align-bottom" @click="setClipboard(distribution.downloadUrl)">file_copy</i>
                              </span>
                            </span>
                          </div>
                        </span>
                      </span>
                    </span>
                    <hr>
                  </span>
                </li>
              </ul>
            </div>
          </div>
        </div>
      </div>
      <!-- KEYWORDS -->
      <div class="mt-2" v-if="keywords.length > 0">
        <div class="row">
          <div class="col-10 offset-1">
            <div class="row">
              <span class="col-4 col-sm-3 col-md-2 mt-md-0 mt-3 pr-0" v-for="(keyword, i) in keywords" :key="`keywords${i}`">
                <small class="d-inline-block w-100 p-2 ml-1 rounded-pill text-center text-white text-truncate bg-primary">
                  {{ keyword }}
                </small>
              </span>
            </div>
          </div>
        </div>
      </div>
      <!-- INFO TABLE -->
      <div class="mt-5" v-if="publisher.name || publisher.resource || publisher.homepage || contact.name || contact.email || contact.resource">
        <div class="row">
          <div class="col-1 my-auto pr-0 text-right" @click="toggleInfo()">
            <span class="arrow text-primary" v-if="!infoVisible">
              <i class="material-icons text-dark">keyboard_arrow_down</i>
            </span>
            <span class="arrow text-primary" v-else>
              <i class="material-icons text-dark">keyboard_arrow_up</i>
            </span>
          </div>
          <div class="col-10 py-2 bg-white">
            <h3 class="heading"
                @click="toggleInfo()">{{ $t('message.datasetDetails.additionalInfo') }}</h3>
          </div>
          <div class="col-10 offset-1"
               v-if="infoVisible">
            <table class="table table-borderless table-responsive pl-3 bg-light">
              <tr v-if="!isEmpty(publisher.name) && !isEmpty(publisher.homepage)">
                <td class="w-25 font-weight-bold">{{ $t('message.metadata.publisher') }}</td>
                <td>
                  <div v-if="has(publisher, 'name') && !isNil(publisher.name)">{{ $t('message.metadata.name') }}: {{ publisher.name }}</div>
                  <div v-if="has(publisher, 'homepage') && !isNil(publisher.homepage)">{{ $t('message.metadata.homepage') }}: {{ publisher.homepage }}</div>
                  <div v-if="has(publisher, 'resource') && !isNil(publisher.resource)">{{ $t('message.metadata.resource') }}:
                    <app-link :to="publisher.resource">{{ publisher.resource }}</app-link>
                  </div>
                </td>
              </tr>
              <tr v-if="!isEmpty(contact.name) && !isEmpty(contact.email)">
                <td class="w-25 font-weight-bold">{{ $t('message.metadata.contactPoints') }}</td>
                <td>
                    <div v-if="has(contact, 'name') && !isNil(contact.name)">{{ $t('message.metadata.name') }}: {{contact.name}}</div>
                    <div v-if="has(contact, 'email') && !isNil(contact.email)">{{ $t($t('message.metadata.email')) }}:
                      <app-link :to="`mailto:${contact.email}`">{{ contact.email}}</app-link>
                    </div>
                    <div v-if="has(contact, 'resource') && !isNil(contact.resource)">{{ $t('message.metadata.resource') }}:
                      <app-link :to="contact.resource">{{ contact.resource }}</app-link>
                    </div>
                    <br>
                </td>
              </tr>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import { mapGetters, mapActions } from 'vuex';
  import {
    has,
    isNil,
    isEmpty,
    isArray,
    isObject,
  } from 'lodash';
  import dateFilters from '../../filters/dateFilters';
  import DatasetDetailsEditButton from '../EDP2-datasetDetails-editButton';
  import DatasetDetailsDeleteButton from '../EDP2-datasetDetails-deleteButton';
  import AppLink from '../AppLink';

  export default {
    name: 'Review',
    components: {
      datasetDetailsEditButton: DatasetDetailsEditButton,
      datasetDetailsDeleteButton: DatasetDetailsDeleteButton,
      appLink: AppLink,
    },
    data() {
      return {
        infoVisible: true,
        id: '',
        title: '',
        description: '',
        keywords: [],
        catalogue: '',
        categories: [],
        contact: {
          type: '',
          name: '',
          email: '',
        },
        publisher: {
          type: '',
          name: '',
          homepage: '',
        },
        distributions: [],
        files: {},
      };
    },
    props: {},
    computed: {
      ...mapGetters('upload', [
        'getValidate',
        'getAPIUploadData',
      ]),
    },
    methods: {
      ...mapActions('upload', [
        'setStep',
        'setValidate',
        'resetStore',
      ]),
      // Lodash has function
      has,
      isNil,
      isEmpty,
      isArray,
      isObject,
      toggleInfo() {
        this.infoVisible = !this.infoVisible;
      },
      showDownloadDropdown(distribution) {
        return this.showAccessUrl(distribution) || this.showDownloadUrl(distribution);
      },
      showAccessUrl(distribution) {
        return has(distribution, 'accessUrl') && !isNil(distribution.accessUrl) && !isEmpty(distribution.accessUrl);
      },
      showDownloadUrl(distribution) {
        return has(distribution, 'downloadUrl') && !isNil(distribution.downloadUrl) && !isEmpty(distribution.downloadUrl);
      },
      setClipboard(value) {
        const input = document.createElement('INPUT');
        input.value = value;
        document.body.appendChild(input);
        input.select();
        document.execCommand('copy');
        document.body.removeChild(input);
      },
      getDistributionFormat(distribution) {
        return has(distribution, 'format.title') && !isNil(distribution.format.title) ? distribution.format.title : '';
      },
      filterDateFormatEU(date) {
        return dateFilters.formatEU(date);
      },
      loadDataFromLocalStorage() {
        // Read dataset attributes from local storage
        if (localStorage.getItem('catalogue')) {
          this.catalogue = JSON.parse(localStorage.getItem('catalogue'));
        }
        if (localStorage.getItem('ID')) {
          this.id = JSON.parse(localStorage.getItem('ID'));
        }
        if (localStorage.getItem('title')) {
          this.title = JSON.parse(localStorage.getItem('title'));
        }
        if (localStorage.getItem('description')) {
          this.description = JSON.parse(localStorage.getItem('description'));
        }
        if (localStorage.getItem('keywords')) {
          this.keywords = JSON.parse(localStorage.getItem('keywords'));
        }
        if (localStorage.getItem('categories')) {
          this.categories = JSON.parse(localStorage.getItem('categories'));
        }
        if (localStorage.getItem('contact')) {
          this.contact = JSON.parse(localStorage.getItem('contact'));
        }
        if (localStorage.getItem('publisher')) {
          this.publisher = JSON.parse(localStorage.getItem('publisher'));
        }
        if (localStorage.getItem('distributions')) {
          this.distributions = JSON.parse(localStorage.getItem('distributions'));
        }
        if (localStorage.getItem('files')) {
          this.files = JSON.parse(localStorage.getItem('files'));
        }
      },
      next() {
        this.resetStore();
      },
    },
    watch: {
      getValidate: {
        handler(validate) {
          if (validate) {
            // Call next function
            this.next();
            // Reset Validate State
            this.setValidate(false);
          }
        },
      },
    },
    mounted() {
      this.loadDataFromLocalStorage();
    },
  };
</script>

<style lang="scss" scoped>
  .heading, .description, .arrow {
    cursor: pointer;
  }

  .options, .download {
    .dropdown-menu {
      min-width: 300px;
      .dropdown-item {
        &:hover {
          color: initial;
          background-color: initial;
        }
      }
    }
  }

  .circle {
    width: 40px;
    height: 40px;
    margin: 0 auto;
    padding: 20px 0;
    font-size: 12px;
    line-height: 1px;
    border-radius: 50%;
    background-color: #000000;
    &[type="HTML"] {
      background-color: #55a1ce;
    }
    &[type="JSON"] {
      background-color: #ef7100;
    }
    &[type="XML"] {
      background-color: #ef7100;
    }
    &[type="TXT"] {
      background-color: #74cbec;
    }
    &[type="CSV"] {
      background-color: #dfb100;
    }
    &[type="XLS"] {
      background-color: #2db55d;
    }
    &[type="ZIP"] {
      background-color: #686868;
    }
    &[type="API"] {
      background-color: #ec96be;
    }
    &[type="PDF"] {
      background-color: #e0051e;
    }
    &[type="RDF"],
    &[type="NQUAD"],
    &[type="NTRIPLES"],
    &[type="TURTLE"] {
      background-color: #0b4498;
    }
  }
</style>
